require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LINUX_VHOST_H)) {
    eval 'sub _LINUX_VHOST_H () {1;}' unless defined(&_LINUX_VHOST_H);
    require 'linux/vhost_types.ph';
    require 'linux/types.ph';
    require 'linux/ioctl.ph';
    eval 'sub VHOST_FILE_UNBIND () {-1;}' unless defined(&VHOST_FILE_UNBIND);
    eval 'sub VHOST_VIRTIO () {0xaf;}' unless defined(&VHOST_VIRTIO);
    eval 'sub VHOST_GET_FEATURES () { &_IOR( &VHOST_VIRTIO, 0x,  &__u64);}' unless defined(&VHOST_GET_FEATURES);
    eval 'sub VHOST_SET_FEATURES () { &_IOW( &VHOST_VIRTIO, 0x,  &__u64);}' unless defined(&VHOST_SET_FEATURES);
    eval 'sub VHOST_SET_OWNER () { &_IO( &VHOST_VIRTIO, 0x1);}' unless defined(&VHOST_SET_OWNER);
    eval 'sub VHOST_RESET_OWNER () { &_IO( &VHOST_VIRTIO, 0x2);}' unless defined(&VHOST_RESET_OWNER);
    eval 'sub VHOST_SET_MEM_TABLE () { &_IOW( &VHOST_VIRTIO, 0x3, \'struct vhost_memory\');}' unless defined(&VHOST_SET_MEM_TABLE);
    eval 'sub VHOST_SET_LOG_BASE () { &_IOW( &VHOST_VIRTIO, 0x4,  &__u64);}' unless defined(&VHOST_SET_LOG_BASE);
    eval 'sub VHOST_SET_LOG_FD () { &_IOW( &VHOST_VIRTIO, 0x7, \'int\');}' unless defined(&VHOST_SET_LOG_FD);
    eval 'sub VHOST_SET_VRING_NUM () { &_IOW( &VHOST_VIRTIO, 0x10, \'struct vhost_vring_state\');}' unless defined(&VHOST_SET_VRING_NUM);
    eval 'sub VHOST_SET_VRING_ADDR () { &_IOW( &VHOST_VIRTIO, 0x11, \'struct vhost_vring_addr\');}' unless defined(&VHOST_SET_VRING_ADDR);
    eval 'sub VHOST_SET_VRING_BASE () { &_IOW( &VHOST_VIRTIO, 0x12, \'struct vhost_vring_state\');}' unless defined(&VHOST_SET_VRING_BASE);
    eval 'sub VHOST_GET_VRING_BASE () { &_IOWR( &VHOST_VIRTIO, 0x12, \'struct vhost_vring_state\');}' unless defined(&VHOST_GET_VRING_BASE);
    eval 'sub VHOST_VRING_LITTLE_ENDIAN () {0;}' unless defined(&VHOST_VRING_LITTLE_ENDIAN);
    eval 'sub VHOST_VRING_BIG_ENDIAN () {1;}' unless defined(&VHOST_VRING_BIG_ENDIAN);
    eval 'sub VHOST_SET_VRING_ENDIAN () { &_IOW( &VHOST_VIRTIO, 0x13, \'struct vhost_vring_state\');}' unless defined(&VHOST_SET_VRING_ENDIAN);
    eval 'sub VHOST_GET_VRING_ENDIAN () { &_IOW( &VHOST_VIRTIO, 0x14, \'struct vhost_vring_state\');}' unless defined(&VHOST_GET_VRING_ENDIAN);
    eval 'sub VHOST_SET_VRING_KICK () { &_IOW( &VHOST_VIRTIO, 0x20, \'struct vhost_vring_file\');}' unless defined(&VHOST_SET_VRING_KICK);
    eval 'sub VHOST_SET_VRING_CALL () { &_IOW( &VHOST_VIRTIO, 0x21, \'struct vhost_vring_file\');}' unless defined(&VHOST_SET_VRING_CALL);
    eval 'sub VHOST_SET_VRING_ERR () { &_IOW( &VHOST_VIRTIO, 0x22, \'struct vhost_vring_file\');}' unless defined(&VHOST_SET_VRING_ERR);
    eval 'sub VHOST_SET_VRING_BUSYLOOP_TIMEOUT () { &_IOW( &VHOST_VIRTIO, 0x23, \'struct vhost_vring_state\');}' unless defined(&VHOST_SET_VRING_BUSYLOOP_TIMEOUT);
    eval 'sub VHOST_GET_VRING_BUSYLOOP_TIMEOUT () { &_IOW( &VHOST_VIRTIO, 0x24, \'struct vhost_vring_state\');}' unless defined(&VHOST_GET_VRING_BUSYLOOP_TIMEOUT);
    eval 'sub VHOST_SET_BACKEND_FEATURES () { &_IOW( &VHOST_VIRTIO, 0x25,  &__u64);}' unless defined(&VHOST_SET_BACKEND_FEATURES);
    eval 'sub VHOST_GET_BACKEND_FEATURES () { &_IOR( &VHOST_VIRTIO, 0x26,  &__u64);}' unless defined(&VHOST_GET_BACKEND_FEATURES);
    eval 'sub VHOST_NET_SET_BACKEND () { &_IOW( &VHOST_VIRTIO, 0x30, \'struct vhost_vring_file\');}' unless defined(&VHOST_NET_SET_BACKEND);
    eval 'sub VHOST_SCSI_SET_ENDPOINT () { &_IOW( &VHOST_VIRTIO, 0x40, \'struct vhost_scsi_target\');}' unless defined(&VHOST_SCSI_SET_ENDPOINT);
    eval 'sub VHOST_SCSI_CLEAR_ENDPOINT () { &_IOW( &VHOST_VIRTIO, 0x41, \'struct vhost_scsi_target\');}' unless defined(&VHOST_SCSI_CLEAR_ENDPOINT);
    eval 'sub VHOST_SCSI_GET_ABI_VERSION () { &_IOW( &VHOST_VIRTIO, 0x42, \'int\');}' unless defined(&VHOST_SCSI_GET_ABI_VERSION);
    eval 'sub VHOST_SCSI_SET_EVENTS_MISSED () { &_IOW( &VHOST_VIRTIO, 0x43,  &__u32);}' unless defined(&VHOST_SCSI_SET_EVENTS_MISSED);
    eval 'sub VHOST_SCSI_GET_EVENTS_MISSED () { &_IOW( &VHOST_VIRTIO, 0x44,  &__u32);}' unless defined(&VHOST_SCSI_GET_EVENTS_MISSED);
    eval 'sub VHOST_VSOCK_SET_GUEST_CID () { &_IOW( &VHOST_VIRTIO, 0x60,  &__u64);}' unless defined(&VHOST_VSOCK_SET_GUEST_CID);
    eval 'sub VHOST_VSOCK_SET_RUNNING () { &_IOW( &VHOST_VIRTIO, 0x61, \'int\');}' unless defined(&VHOST_VSOCK_SET_RUNNING);
    eval 'sub VHOST_VDPA_GET_DEVICE_ID () { &_IOR( &VHOST_VIRTIO, 0x70,  &__u32);}' unless defined(&VHOST_VDPA_GET_DEVICE_ID);
    eval 'sub VHOST_VDPA_GET_STATUS () { &_IOR( &VHOST_VIRTIO, 0x71,  &__u8);}' unless defined(&VHOST_VDPA_GET_STATUS);
    eval 'sub VHOST_VDPA_SET_STATUS () { &_IOW( &VHOST_VIRTIO, 0x72,  &__u8);}' unless defined(&VHOST_VDPA_SET_STATUS);
    eval 'sub VHOST_VDPA_GET_CONFIG () { &_IOR( &VHOST_VIRTIO, 0x73, \'struct vhost_vdpa_config\');}' unless defined(&VHOST_VDPA_GET_CONFIG);
    eval 'sub VHOST_VDPA_SET_CONFIG () { &_IOW( &VHOST_VIRTIO, 0x74, \'struct vhost_vdpa_config\');}' unless defined(&VHOST_VDPA_SET_CONFIG);
    eval 'sub VHOST_VDPA_SET_VRING_ENABLE () { &_IOW( &VHOST_VIRTIO, 0x75, \'struct vhost_vring_state\');}' unless defined(&VHOST_VDPA_SET_VRING_ENABLE);
    eval 'sub VHOST_VDPA_GET_VRING_NUM () { &_IOR( &VHOST_VIRTIO, 0x76,  &__u16);}' unless defined(&VHOST_VDPA_GET_VRING_NUM);
    eval 'sub VHOST_VDPA_SET_CONFIG_CALL () { &_IOW( &VHOST_VIRTIO, 0x77, \'int\');}' unless defined(&VHOST_VDPA_SET_CONFIG_CALL);
    eval 'sub VHOST_VDPA_GET_IOVA_RANGE () { &_IOR( &VHOST_VIRTIO, 0x78, \'struct vhost_vdpa_iova_range\');}' unless defined(&VHOST_VDPA_GET_IOVA_RANGE);
    eval 'sub VHOST_VDPA_GET_CONFIG_SIZE () { &_IOR( &VHOST_VIRTIO, 0x79,  &__u32);}' unless defined(&VHOST_VDPA_GET_CONFIG_SIZE);
    eval 'sub VHOST_VDPA_GET_VQS_COUNT () { &_IOR( &VHOST_VIRTIO, 0x80,  &__u32);}' unless defined(&VHOST_VDPA_GET_VQS_COUNT);
    eval 'sub VHOST_VDPA_GET_GROUP_NUM () { &_IOR( &VHOST_VIRTIO, 0x81,  &__u32);}' unless defined(&VHOST_VDPA_GET_GROUP_NUM);
    eval 'sub VHOST_VDPA_GET_AS_NUM () { &_IOR( &VHOST_VIRTIO, 0x7a, \'unsigned int\');}' unless defined(&VHOST_VDPA_GET_AS_NUM);
    eval 'sub VHOST_VDPA_GET_VRING_GROUP () { &_IOWR( &VHOST_VIRTIO, 0x7b, \'struct vhost_vring_state\');}' unless defined(&VHOST_VDPA_GET_VRING_GROUP);
    eval 'sub VHOST_VDPA_SET_GROUP_ASID () { &_IOW( &VHOST_VIRTIO, 0x7c, \'struct vhost_vring_state\');}' unless defined(&VHOST_VDPA_SET_GROUP_ASID);
    eval 'sub VHOST_VDPA_SUSPEND () { &_IO( &VHOST_VIRTIO, 0x7d);}' unless defined(&VHOST_VDPA_SUSPEND);
    eval 'sub VHOST_VDPA_RESUME () { &_IO( &VHOST_VIRTIO, 0x7e);}' unless defined(&VHOST_VDPA_RESUME);
}
1;
