require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MATH_H)) {
    eval 'sub _MATH_H () {1;}' unless defined(&_MATH_H);
    eval 'sub __GLIBC_INTERNAL_STARTING_HEADER_IMPLEMENTATION () {1;}' unless defined(&__GLIBC_INTERNAL_STARTING_HEADER_IMPLEMENTATION);
    require 'bits/libc-header-start.ph';
    if(defined (&log)  && defined (&__GNUC__)) {
	warn("A\ macro\ called\ log\ was\ already\ defined\ when\ \<math\.h\>\ was\ included\.");
	warn("This\ will\ cause\ compilation\ problems\.");
    }
    require 'bits/types.ph';
    require 'bits/math-vector.ph';
    require 'bits/floatn.ph';
    if( &__GNUC_PREREQ (3, 3)) {
	eval 'sub HUGE_VAL () {( &__builtin_huge_val ());}' unless defined(&HUGE_VAL);
    } else {
	eval 'sub HUGE_VAL () {1 &e10000;}' unless defined(&HUGE_VAL);
    }
    if(defined(&__USE_ISOC99)) {
	if( &__GNUC_PREREQ (3, 3)) {
	    eval 'sub HUGE_VALF () {( &__builtin_huge_valf ());}' unless defined(&HUGE_VALF);
	    eval 'sub HUGE_VALL () {( &__builtin_huge_vall ());}' unless defined(&HUGE_VALL);
	} else {
	    eval 'sub HUGE_VALF () {1 &e10000f;}' unless defined(&HUGE_VALF);
	    eval 'sub HUGE_VALL () {1 &e10000L;}' unless defined(&HUGE_VALL);
	}
    }
    if((defined(&__HAVE_FLOAT16) ? &__HAVE_FLOAT16 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub HUGE_VAL_F16 () {( &__builtin_huge_valf16 ());}' unless defined(&HUGE_VAL_F16);
    }
    if((defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub HUGE_VAL_F32 () {( &__builtin_huge_valf32 ());}' unless defined(&HUGE_VAL_F32);
    }
    if((defined(&__HAVE_FLOAT64) ? &__HAVE_FLOAT64 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub HUGE_VAL_F64 () {( &__builtin_huge_valf64 ());}' unless defined(&HUGE_VAL_F64);
    }
    if((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub HUGE_VAL_F128 () {( &__builtin_huge_valf128 ());}' unless defined(&HUGE_VAL_F128);
    }
    if((defined(&__HAVE_FLOAT32X) ? &__HAVE_FLOAT32X : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub HUGE_VAL_F32X () {( &__builtin_huge_valf32x ());}' unless defined(&HUGE_VAL_F32X);
    }
    if((defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub HUGE_VAL_F64X () {( &__builtin_huge_valf64x ());}' unless defined(&HUGE_VAL_F64X);
    }
    if((defined(&__HAVE_FLOAT128X) ? &__HAVE_FLOAT128X : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub HUGE_VAL_F128X () {( &__builtin_huge_valf128x ());}' unless defined(&HUGE_VAL_F128X);
    }
    if(defined(&__USE_ISOC99)) {
	if( &__GNUC_PREREQ (3, 3)) {
	    eval 'sub INFINITY () {( &__builtin_inff ());}' unless defined(&INFINITY);
	} else {
	    eval 'sub INFINITY () { &HUGE_VALF;}' unless defined(&INFINITY);
	}
	if( &__GNUC_PREREQ (3, 3)) {
	    eval 'sub NAN () {( &__builtin_nanf (""));}' unless defined(&NAN);
	} else {
	    eval 'sub NAN () {(0.0 &f / 0.0 &f);}' unless defined(&NAN);
	}
    }
    if( &__GLIBC_USE ((defined(&IEC_60559_BFP_EXT) ? &IEC_60559_BFP_EXT : undef))) {
	if( &__GNUC_PREREQ (3, 3)) {
	    eval 'sub SNANF () {( &__builtin_nansf (""));}' unless defined(&SNANF);
	    eval 'sub SNAN () {( &__builtin_nans (""));}' unless defined(&SNAN);
	    eval 'sub SNANL () {( &__builtin_nansl (""));}' unless defined(&SNANL);
	}
    }
    if(((defined(&__HAVE_FLOAT16) ? &__HAVE_FLOAT16 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))  && (defined (&__USE_GNU) || ! &__GLIBC_USE ((defined(&ISOC2X) ? &ISOC2X : undef))))) {
	eval 'sub SNANF16 () {( &__builtin_nansf16 (""));}' unless defined(&SNANF16);
    }
    if(((defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))  && (defined (&__USE_GNU) || ! &__GLIBC_USE ((defined(&ISOC2X) ? &ISOC2X : undef))))) {
	eval 'sub SNANF32 () {( &__builtin_nansf32 (""));}' unless defined(&SNANF32);
    }
    if(((defined(&__HAVE_FLOAT64) ? &__HAVE_FLOAT64 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))  && (defined (&__USE_GNU) || ! &__GLIBC_USE ((defined(&ISOC2X) ? &ISOC2X : undef))))) {
	eval 'sub SNANF64 () {( &__builtin_nansf64 (""));}' unless defined(&SNANF64);
    }
    if(((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))  && (defined (&__USE_GNU) || ! &__GLIBC_USE ((defined(&ISOC2X) ? &ISOC2X : undef))))) {
	eval 'sub SNANF128 () {( &__builtin_nansf128 (""));}' unless defined(&SNANF128);
    }
    if(((defined(&__HAVE_FLOAT32X) ? &__HAVE_FLOAT32X : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))  && (defined (&__USE_GNU) || ! &__GLIBC_USE ((defined(&ISOC2X) ? &ISOC2X : undef))))) {
	eval 'sub SNANF32X () {( &__builtin_nansf32x (""));}' unless defined(&SNANF32X);
    }
    if(((defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))  && (defined (&__USE_GNU) || ! &__GLIBC_USE ((defined(&ISOC2X) ? &ISOC2X : undef))))) {
	eval 'sub SNANF64X () {( &__builtin_nansf64x (""));}' unless defined(&SNANF64X);
    }
    if(((defined(&__HAVE_FLOAT128X) ? &__HAVE_FLOAT128X : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))  && (defined (&__USE_GNU) || ! &__GLIBC_USE ((defined(&ISOC2X) ? &ISOC2X : undef))))) {
	eval 'sub SNANF128X () {( &__builtin_nansf128x (""));}' unless defined(&SNANF128X);
    }
    require 'bits/flt-eval-method.ph';
    if(defined(&__USE_ISOC99)) {
	if((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 0|| (defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 16) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 1) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 2) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 32) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 33) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 64) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 65) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 128) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 129) {
	} else {
	    die("Unknown __GLIBC_FLT_EVAL_METHOD");
	}
    }
    require 'bits/fp-logb.ph';
    if(defined(&__USE_ISOC99)) {
	if((defined(&__FP_LOGB0_IS_MIN) ? &__FP_LOGB0_IS_MIN : undef)) {
	    eval 'sub FP_ILOGB0 () {(-2147483647- 1);}' unless defined(&FP_ILOGB0);
	} else {
	    eval 'sub FP_ILOGB0 () {(-2147483647);}' unless defined(&FP_ILOGB0);
	}
	if((defined(&__FP_LOGBNAN_IS_MIN) ? &__FP_LOGBNAN_IS_MIN : undef)) {
	    eval 'sub FP_ILOGBNAN () {(-2147483647- 1);}' unless defined(&FP_ILOGBNAN);
	} else {
	    eval 'sub FP_ILOGBNAN () {2147483647;}' unless defined(&FP_ILOGBNAN);
	}
    }
    if( &__GLIBC_USE ((defined(&IEC_60559_BFP_EXT_C2X) ? &IEC_60559_BFP_EXT_C2X : undef))) {
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 32) {
	    eval 'sub __FP_LONG_MAX () {0x7fffffff;}' unless defined(&__FP_LONG_MAX);
	} else {
	    eval 'sub __FP_LONG_MAX () {0x7fffffffffffffff;}' unless defined(&__FP_LONG_MAX);
	}
	if((defined(&__FP_LOGB0_IS_MIN) ? &__FP_LOGB0_IS_MIN : undef)) {
	    eval 'sub FP_LLOGB0 () {(- &__FP_LONG_MAX - 1);}' unless defined(&FP_LLOGB0);
	} else {
	    eval 'sub FP_LLOGB0 () {(- &__FP_LONG_MAX);}' unless defined(&FP_LLOGB0);
	}
	if((defined(&__FP_LOGBNAN_IS_MIN) ? &__FP_LOGBNAN_IS_MIN : undef)) {
	    eval 'sub FP_LLOGBNAN () {(- &__FP_LONG_MAX - 1);}' unless defined(&FP_LLOGBNAN);
	} else {
	    eval 'sub FP_LLOGBNAN () { &__FP_LONG_MAX;}' unless defined(&FP_LLOGBNAN);
	}
    }
    require 'bits/fp-fast.ph';
    if( &__GLIBC_USE ((defined(&IEC_60559_BFP_EXT_C2X) ? &IEC_60559_BFP_EXT_C2X : undef))) {
	eval("sub FP_INT_UPWARD () { FP_INT_UPWARD=0; }") unless defined(&FP_INT_UPWARD);
	eval("sub FP_INT_UPWARD () { 1; }") unless defined(&FP_INT_UPWARD);
	eval("sub FP_INT_DOWNWARD () { FP_INT_DOWNWARD=1; }") unless defined(&FP_INT_DOWNWARD);
	eval("sub FP_INT_DOWNWARD () { 1; }") unless defined(&FP_INT_DOWNWARD);
	eval("sub FP_INT_TOWARDZERO () { FP_INT_TOWARDZERO=2; }") unless defined(&FP_INT_TOWARDZERO);
	eval("sub FP_INT_TOWARDZERO () { 1; }") unless defined(&FP_INT_TOWARDZERO);
	eval("sub FP_INT_TONEARESTFROMZERO () { FP_INT_TONEARESTFROMZERO=3; }") unless defined(&FP_INT_TONEARESTFROMZERO);
	eval("sub FP_INT_TONEARESTFROMZERO () { 1; }") unless defined(&FP_INT_TONEARESTFROMZERO);
	eval("sub FP_INT_TONEAREST () { FP_INT_TONEAREST=4; }") unless defined(&FP_INT_TONEAREST);
	eval("sub FP_INT_TONEAREST () { 1; }") unless defined(&FP_INT_TONEAREST);
    }
    eval 'sub __SIMD_DECL {
        my($function) = @_;
	    eval q( &__CONCAT ( &__DECL_SIMD_, $function));
    }' unless defined(&__SIMD_DECL);
    eval 'sub __MATHCALL_VEC {
        my($function, $suffix, $args) = @_;
	    eval q( &__SIMD_DECL ( &__MATH_PRECNAME ($function, $suffix))  &__MATHCALL ($function, $suffix, $args));
    }' unless defined(&__MATHCALL_VEC);
    eval 'sub __MATHDECL_VEC {
        my($type, $function,$suffix, $args) = @_;
	    eval q( &__SIMD_DECL ( &__MATH_PRECNAME ($function, $suffix))  &__MATHDECL($type, $function,$suffix, $args));
    }' unless defined(&__MATHDECL_VEC);
    eval 'sub __MATHCALL {
        my($function,$suffix, $args) = @_;
	    eval q( &__MATHDECL ( &_Mdouble_,$function,$suffix, $args));
    }' unless defined(&__MATHCALL);
    eval 'sub __MATHDECL {
        my($type, $function,$suffix, $args) = @_;
	    eval q( &__MATHDECL_1($type, $function,$suffix, $args);  &__MATHDECL_1($type,  &__CONCAT( &__,$function),$suffix, $args));
    }' unless defined(&__MATHDECL);
    eval 'sub __MATHCALLX {
        my($function,$suffix, $args, $attrib) = @_;
	    eval q( &__MATHDECLX ( &_Mdouble_,$function,$suffix, $args, $attrib));
    }' unless defined(&__MATHCALLX);
    eval 'sub __MATHDECLX {
        my($type, $function,$suffix, $args, $attrib) = @_;
	    eval q( &__MATHDECL_1($type, $function,$suffix, $args)  &__attribute__ ($attrib);  &__MATHDECL_1($type,  &__CONCAT( &__,$function),$suffix, $args)  &__attribute__ ($attrib));
    }' unless defined(&__MATHDECLX);
    eval 'sub __MATHDECL_1_IMPL {
        my($type, $function, $suffix, $args) = @_;
	    eval q( &extern $type  &__MATH_PRECNAME($function,$suffix) $args  &__THROW);
    }' unless defined(&__MATHDECL_1_IMPL);
    eval 'sub __MATHDECL_1 {
        my($type, $function, $suffix, $args) = @_;
	    eval q( &__MATHDECL_1_IMPL($type, $function, $suffix, $args));
    }' unless defined(&__MATHDECL_1);
    eval 'sub __MATHDECL_ALIAS {
        my($type, $function, $suffix, $args, $alias) = @_;
	    eval q( &__MATHDECL_1($type, $function, $suffix, $args));
    }' unless defined(&__MATHDECL_ALIAS);
    eval 'sub __MATHREDIR {
        my($type, $function, $suffix, $args, $to) = @_;
	    eval q( &extern $type  &__REDIRECT_NTH ( &__MATH_PRECNAME ($function, $suffix), $args, $to));
    }' unless defined(&__MATHREDIR);
    eval 'sub _Mdouble_ () {\'double\';}' unless defined(&_Mdouble_);
    eval 'sub __MATH_PRECNAME {
        my($name,$r) = @_;
	    eval q( &__CONCAT($name,$r));
    }' unless defined(&__MATH_PRECNAME);
    eval 'sub __MATH_DECLARING_DOUBLE () {1;}' unless defined(&__MATH_DECLARING_DOUBLE);
    eval 'sub __MATH_DECLARING_FLOATN () {0;}' unless defined(&__MATH_DECLARING_FLOATN);
    require 'bits/mathcalls-helper-functions.ph';
    require 'bits/mathcalls.ph';
    undef(&_Mdouble_) if defined(&_Mdouble_);
    undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
    undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
    undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
    if(defined(&__USE_ISOC99)) {
	eval 'sub _Mdouble_ () {\'float\';}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name,$r) = @_;
    	    eval q($name &f$r);
	}' unless defined(&__MATH_PRECNAME);
	eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	eval 'sub __MATH_DECLARING_FLOATN () {0;}' unless defined(&__MATH_DECLARING_FLOATN);
	require 'bits/mathcalls-helper-functions.ph';
	require 'bits/mathcalls.ph';
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
	if(!(defined (&__NO_LONG_DOUBLE_MATH)  && defined (&_LIBC)) || defined (&__LDBL_COMPAT) || defined (&_LIBC_TEST)) {
	    if(defined(&__LDBL_COMPAT)) {
		if(defined(&__USE_ISOC99)) {
		    if(defined(&__REDIRECT_NTH)) {
		    }
		}
		undef(&__MATHDECL_1) if defined(&__MATHDECL_1);
		eval 'sub __MATHDECL_1 {
		    my($type, $function,$suffix, $args) = @_;
    		    eval q( &__MATHREDIR($type, $function, $suffix, $args,  &__CONCAT($function,$suffix)));
		}' unless defined(&__MATHDECL_1);
	    }
 elsif((defined(&__LDOUBLE_REDIRECTS_TO_FLOAT128_ABI) ? &__LDOUBLE_REDIRECTS_TO_FLOAT128_ABI : undef) == 1) {
		if(defined(&__REDIRECT_NTH)) {
		    if(defined(&__USE_ISOC99)) {
			eval 'sub __dremieee128 () { &__remainderieee128;}' unless defined(&__dremieee128);
			eval 'sub __gammaieee128 () { &__lgammaieee128;}' unless defined(&__gammaieee128);
		    }
		}
		undef(&__MATHDECL_1) if defined(&__MATHDECL_1);
		undef(&__MATHDECL_ALIAS) if defined(&__MATHDECL_ALIAS);
		eval 'sub __REDIRTO {
		    my($function, $suffix) = @_;
    		    eval q( &__  $function   &ieee128  $suffix);
		}' unless defined(&__REDIRTO);
		eval 'sub __REDIRTO_ALT {
		    my($function, $suffix) = @_;
    		    eval q( &__  $function   &f128  $suffix);
		}' unless defined(&__REDIRTO_ALT);
		eval 'sub __MATHDECL_1 {
		    my($type, $function, $suffix, $args) = @_;
    		    eval q( &__MATHREDIR ($type, $function, $suffix, $args,  &__REDIRTO ($function, $suffix)));
		}' unless defined(&__MATHDECL_1);
		eval 'sub __MATHDECL_ALIAS {
		    my($type, $function, $suffix, $args, $alias) = @_;
    		    eval q( &__MATHREDIR ($type, $function, $suffix, $args,  &__REDIRTO_ALT ($alias, $suffix)));
		}' unless defined(&__MATHDECL_ALIAS);
	    }
	    eval 'sub _Mdouble_ () {\'long double\';}' unless defined(&_Mdouble_);
	    eval 'sub __MATH_PRECNAME {
	        my($name,$r) = @_;
    		eval q($name &l$r);
	    }' unless defined(&__MATH_PRECNAME);
	    eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	    eval 'sub __MATH_DECLARING_FLOATN () {0;}' unless defined(&__MATH_DECLARING_FLOATN);
	    eval 'sub __MATH_DECLARE_LDOUBLE () {1;}' unless defined(&__MATH_DECLARE_LDOUBLE);
	    require 'bits/mathcalls-helper-functions.ph';
	    require 'bits/mathcalls.ph';
	    undef(&_Mdouble_) if defined(&_Mdouble_);
	    undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	    undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	    undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
	    if(defined (&__LDBL_COMPAT) || (defined(&__LDOUBLE_REDIRECTS_TO_FLOAT128_ABI) ? &__LDOUBLE_REDIRECTS_TO_FLOAT128_ABI : undef) == 1) {
		undef(&__REDIRTO) if defined(&__REDIRTO);
		undef(&__REDIRTO_ALT) if defined(&__REDIRTO_ALT);
		undef(&__MATHDECL_1) if defined(&__MATHDECL_1);
		undef(&__MATHDECL_ALIAS) if defined(&__MATHDECL_ALIAS);
		eval 'sub __MATHDECL_1 {
		    my($type, $function, $suffix, $args) = @_;
    		    eval q( &__MATHDECL_1_IMPL($type, $function, $suffix, $args));
		}' unless defined(&__MATHDECL_1);
		eval 'sub __MATHDECL_ALIAS {
		    my($type, $function, $suffix, $args, $alias) = @_;
    		    eval q( &__MATHDECL_1($type, $function, $suffix, $args));
		}' unless defined(&__MATHDECL_ALIAS);
	    }
	}
    }
    if((defined(&__HAVE_DISTINCT_FLOAT16) ? &__HAVE_DISTINCT_FLOAT16 : undef) || ((defined(&__HAVE_FLOAT16) ? &__HAVE_FLOAT16 : undef)  && !defined (&_LIBC))) {
	eval 'sub _Mdouble_ () { &_Float16;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name,$r) = @_;
    	    eval q($name &f16$r);
	}' unless defined(&__MATH_PRECNAME);
	eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	eval 'sub __MATH_DECLARING_FLOATN () {1;}' unless defined(&__MATH_DECLARING_FLOATN);
	if((defined(&__HAVE_DISTINCT_FLOAT16) ? &__HAVE_DISTINCT_FLOAT16 : undef)) {
	    require 'bits/mathcalls-helper-functions.ph';
	}
	if( &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	    require 'bits/mathcalls.ph';
	}
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
    }
    if((defined(&__HAVE_DISTINCT_FLOAT32) ? &__HAVE_DISTINCT_FLOAT32 : undef) || ((defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)  && !defined (&_LIBC))) {
	eval 'sub _Mdouble_ () { &_Float32;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name,$r) = @_;
    	    eval q($name &f32$r);
	}' unless defined(&__MATH_PRECNAME);
	eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	eval 'sub __MATH_DECLARING_FLOATN () {1;}' unless defined(&__MATH_DECLARING_FLOATN);
	if((defined(&__HAVE_DISTINCT_FLOAT32) ? &__HAVE_DISTINCT_FLOAT32 : undef)) {
	    require 'bits/mathcalls-helper-functions.ph';
	}
	if( &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	    require 'bits/mathcalls.ph';
	}
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
    }
    if((defined(&__HAVE_DISTINCT_FLOAT64) ? &__HAVE_DISTINCT_FLOAT64 : undef) || ((defined(&__HAVE_FLOAT64) ? &__HAVE_FLOAT64 : undef)  && !defined (&_LIBC))) {
	eval 'sub _Mdouble_ () { &_Float64;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name,$r) = @_;
    	    eval q($name &f64$r);
	}' unless defined(&__MATH_PRECNAME);
	eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	eval 'sub __MATH_DECLARING_FLOATN () {1;}' unless defined(&__MATH_DECLARING_FLOATN);
	if((defined(&__HAVE_DISTINCT_FLOAT64) ? &__HAVE_DISTINCT_FLOAT64 : undef)) {
	    require 'bits/mathcalls-helper-functions.ph';
	}
	if( &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	    require 'bits/mathcalls.ph';
	}
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
    }
    if((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef) || ((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  && !defined (&_LIBC))) {
	eval 'sub _Mdouble_ () { &_Float128;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name,$r) = @_;
    	    eval q($name &f128$r);
	}' unless defined(&__MATH_PRECNAME);
	eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	eval 'sub __MATH_DECLARING_FLOATN () {1;}' unless defined(&__MATH_DECLARING_FLOATN);
	if((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef)) {
	    require 'bits/mathcalls-helper-functions.ph';
	}
	if( &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	    require 'bits/mathcalls.ph';
	}
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
    }
    if((defined(&__HAVE_DISTINCT_FLOAT32X) ? &__HAVE_DISTINCT_FLOAT32X : undef) || ((defined(&__HAVE_FLOAT32X) ? &__HAVE_FLOAT32X : undef)  && !defined (&_LIBC))) {
	eval 'sub _Mdouble_ () { &_Float32x;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name,$r) = @_;
    	    eval q($name &f32x$r);
	}' unless defined(&__MATH_PRECNAME);
	eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	eval 'sub __MATH_DECLARING_FLOATN () {1;}' unless defined(&__MATH_DECLARING_FLOATN);
	if((defined(&__HAVE_DISTINCT_FLOAT32X) ? &__HAVE_DISTINCT_FLOAT32X : undef)) {
	    require 'bits/mathcalls-helper-functions.ph';
	}
	if( &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	    require 'bits/mathcalls.ph';
	}
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
    }
    if((defined(&__HAVE_DISTINCT_FLOAT64X) ? &__HAVE_DISTINCT_FLOAT64X : undef) || ((defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)  && !defined (&_LIBC))) {
	eval 'sub _Mdouble_ () { &_Float64x;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name,$r) = @_;
    	    eval q($name &f64x$r);
	}' unless defined(&__MATH_PRECNAME);
	eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	eval 'sub __MATH_DECLARING_FLOATN () {1;}' unless defined(&__MATH_DECLARING_FLOATN);
	if((defined(&__HAVE_DISTINCT_FLOAT64X) ? &__HAVE_DISTINCT_FLOAT64X : undef)) {
	    require 'bits/mathcalls-helper-functions.ph';
	}
	if( &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	    require 'bits/mathcalls.ph';
	}
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
    }
    if((defined(&__HAVE_DISTINCT_FLOAT128X) ? &__HAVE_DISTINCT_FLOAT128X : undef) || ((defined(&__HAVE_FLOAT128X) ? &__HAVE_FLOAT128X : undef)  && !defined (&_LIBC))) {
	eval 'sub _Mdouble_ () { &_Float128x;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name,$r) = @_;
    	    eval q($name &f128x$r);
	}' unless defined(&__MATH_PRECNAME);
	eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	eval 'sub __MATH_DECLARING_FLOATN () {1;}' unless defined(&__MATH_DECLARING_FLOATN);
	if((defined(&__HAVE_DISTINCT_FLOAT128X) ? &__HAVE_DISTINCT_FLOAT128X : undef)) {
	    require 'bits/mathcalls-helper-functions.ph';
	}
	if( &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	    require 'bits/mathcalls.ph';
	}
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
    }
    undef(&__MATHDECL_1_IMPL) if defined(&__MATHDECL_1_IMPL);
    undef(&__MATHDECL_1) if defined(&__MATHDECL_1);
    undef(&__MATHDECL_ALIAS) if defined(&__MATHDECL_ALIAS);
    undef(&__MATHDECL) if defined(&__MATHDECL);
    undef(&__MATHCALL) if defined(&__MATHCALL);
    eval 'sub __MATHCALL_NARROW_ARGS_1 () {( &_Marg_  &__x);}' unless defined(&__MATHCALL_NARROW_ARGS_1);
    eval 'sub __MATHCALL_NARROW_ARGS_2 () {( &_Marg_  &__x,  &_Marg_  &__y);}' unless defined(&__MATHCALL_NARROW_ARGS_2);
    eval 'sub __MATHCALL_NARROW_ARGS_3 () {( &_Marg_  &__x,  &_Marg_  &__y,  &_Marg_  &__z);}' unless defined(&__MATHCALL_NARROW_ARGS_3);
    eval 'sub __MATHCALL_NARROW_NORMAL {
        my($func, $nargs) = @_;
	    eval q( &extern  &_Mret_ $func  &__MATHCALL_NARROW_ARGS_  $nargs  &__THROW);
    }' unless defined(&__MATHCALL_NARROW_NORMAL);
    eval 'sub __MATHCALL_NARROW_REDIR {
        my($func, $redir, $nargs) = @_;
	    eval q( &extern  &_Mret_  &__REDIRECT_NTH ($func,  &__MATHCALL_NARROW_ARGS_  $nargs, $redir));
    }' unless defined(&__MATHCALL_NARROW_REDIR);
    eval 'sub __MATHCALL_NARROW {
        my($func, $redir, $nargs) = @_;
	    eval q( &__MATHCALL_NARROW_NORMAL ($func, $nargs));
    }' unless defined(&__MATHCALL_NARROW);
    if( &__GLIBC_USE ((defined(&IEC_60559_BFP_EXT_C2X) ? &IEC_60559_BFP_EXT_C2X : undef))) {
	eval 'sub _Mret_ () {\'float\';}' unless defined(&_Mret_);
	eval 'sub _Marg_ () {\'double\';}' unless defined(&_Marg_);
	eval 'sub __MATHCALL_NAME {
	    my($name) = @_;
    	    eval q( &f  $name);
	}' unless defined(&__MATHCALL_NAME);
	require 'bits/mathcalls-narrow.ph';
	undef(&_Mret_) if defined(&_Mret_);
	undef(&_Marg_) if defined(&_Marg_);
	undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	eval 'sub _Mret_ () {\'float\';}' unless defined(&_Mret_);
	eval 'sub _Marg_ () {\'long double\';}' unless defined(&_Marg_);
	eval 'sub __MATHCALL_NAME {
	    my($name) = @_;
    	    eval q( &f  $name   &l);
	}' unless defined(&__MATHCALL_NAME);
	if(defined(&__LDBL_COMPAT)) {
	    eval 'sub __MATHCALL_REDIR_NAME {
	        my($name) = @_;
    		eval q( &f  $name);
	    }' unless defined(&__MATHCALL_REDIR_NAME);
	    eval 'sub __MATHCALL_REDIR_NAME2 {
	        my($name) = @_;
    		eval q( &f  $name);
	    }' unless defined(&__MATHCALL_REDIR_NAME2);
	    undef(&__MATHCALL_NARROW) if defined(&__MATHCALL_NARROW);
	    eval 'sub __MATHCALL_NARROW {
	        my($func, $redir, $nargs) = @_;
    		eval q( &__MATHCALL_NARROW_REDIR ($func, $redir, $nargs));
	    }' unless defined(&__MATHCALL_NARROW);
	}
 elsif((defined(&__LDOUBLE_REDIRECTS_TO_FLOAT128_ABI) ? &__LDOUBLE_REDIRECTS_TO_FLOAT128_ABI : undef) == 1) {
	    eval 'sub __MATHCALL_REDIR_NAME {
	        my($name) = @_;
    		eval q( &__   &f32  $name   &ieee128);
	    }' unless defined(&__MATHCALL_REDIR_NAME);
	    eval 'sub __MATHCALL_REDIR_NAME2 {
	        my($name) = @_;
    		eval q( &__   &f32  $name   &ieee128);
	    }' unless defined(&__MATHCALL_REDIR_NAME2);
	    undef(&__MATHCALL_NARROW) if defined(&__MATHCALL_NARROW);
	    eval 'sub __MATHCALL_NARROW {
	        my($func, $redir, $nargs) = @_;
    		eval q( &__MATHCALL_NARROW_REDIR ($func, $redir, $nargs));
	    }' unless defined(&__MATHCALL_NARROW);
	}
	require 'bits/mathcalls-narrow.ph';
	undef(&_Mret_) if defined(&_Mret_);
	undef(&_Marg_) if defined(&_Marg_);
	undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	if(defined (&__LDBL_COMPAT) || (defined(&__LDOUBLE_REDIRECTS_TO_FLOAT128_ABI) ? &__LDOUBLE_REDIRECTS_TO_FLOAT128_ABI : undef) == 1) {
	    undef(&__MATHCALL_REDIR_NAME) if defined(&__MATHCALL_REDIR_NAME);
	    undef(&__MATHCALL_REDIR_NAME2) if defined(&__MATHCALL_REDIR_NAME2);
	    undef(&__MATHCALL_NARROW) if defined(&__MATHCALL_NARROW);
	    eval 'sub __MATHCALL_NARROW {
	        my($func, $redir, $nargs) = @_;
    		eval q( &__MATHCALL_NARROW_NORMAL ($func, $nargs));
	    }' unless defined(&__MATHCALL_NARROW);
	}
	eval 'sub _Mret_ () {\'double\';}' unless defined(&_Mret_);
	eval 'sub _Marg_ () {\'long double\';}' unless defined(&_Marg_);
	eval 'sub __MATHCALL_NAME {
	    my($name) = @_;
    	    eval q( &d  $name   &l);
	}' unless defined(&__MATHCALL_NAME);
	if(defined(&__LDBL_COMPAT)) {
	    eval 'sub __MATHCALL_REDIR_NAME {
	        my($name) = @_;
    		eval q( &__nldbl_d  $name   &l);
	    }' unless defined(&__MATHCALL_REDIR_NAME);
	    eval 'sub __MATHCALL_REDIR_NAME2 {
	        my($name) = @_;
    		eval q($name);
	    }' unless defined(&__MATHCALL_REDIR_NAME2);
	    undef(&__MATHCALL_NARROW) if defined(&__MATHCALL_NARROW);
	    eval 'sub __MATHCALL_NARROW {
	        my($func, $redir, $nargs) = @_;
    		eval q( &__MATHCALL_NARROW_REDIR ($func, $redir, $nargs));
	    }' unless defined(&__MATHCALL_NARROW);
	}
 elsif((defined(&__LDOUBLE_REDIRECTS_TO_FLOAT128_ABI) ? &__LDOUBLE_REDIRECTS_TO_FLOAT128_ABI : undef) == 1) {
	    eval 'sub __MATHCALL_REDIR_NAME {
	        my($name) = @_;
    		eval q( &__   &f64  $name   &ieee128);
	    }' unless defined(&__MATHCALL_REDIR_NAME);
	    eval 'sub __MATHCALL_REDIR_NAME2 {
	        my($name) = @_;
    		eval q( &__   &f64  $name   &ieee128);
	    }' unless defined(&__MATHCALL_REDIR_NAME2);
	    undef(&__MATHCALL_NARROW) if defined(&__MATHCALL_NARROW);
	    eval 'sub __MATHCALL_NARROW {
	        my($func, $redir, $nargs) = @_;
    		eval q( &__MATHCALL_NARROW_REDIR ($func, $redir, $nargs));
	    }' unless defined(&__MATHCALL_NARROW);
	}
	require 'bits/mathcalls-narrow.ph';
	undef(&_Mret_) if defined(&_Mret_);
	undef(&_Marg_) if defined(&_Marg_);
	undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	if(defined (&__LDBL_COMPAT) || (defined(&__LDOUBLE_REDIRECTS_TO_FLOAT128_ABI) ? &__LDOUBLE_REDIRECTS_TO_FLOAT128_ABI : undef) == 1) {
	    undef(&__MATHCALL_REDIR_NAME) if defined(&__MATHCALL_REDIR_NAME);
	    undef(&__MATHCALL_REDIR_NAME2) if defined(&__MATHCALL_REDIR_NAME2);
	    undef(&__MATHCALL_NARROW) if defined(&__MATHCALL_NARROW);
	    eval 'sub __MATHCALL_NARROW {
	        my($func, $redir, $nargs) = @_;
    		eval q( &__MATHCALL_NARROW_NORMAL ($func, $nargs));
	    }' unless defined(&__MATHCALL_NARROW);
	}
    }
    if( &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	if((defined(&__HAVE_FLOAT16) ? &__HAVE_FLOAT16 : undef)  && (defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)) {
	    eval 'sub _Mret_ () { &_Float16;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float32;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f16  $name   &f32);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT16) ? &__HAVE_FLOAT16 : undef)  && (defined(&__HAVE_FLOAT32X) ? &__HAVE_FLOAT32X : undef)) {
	    eval 'sub _Mret_ () { &_Float16;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float32x;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f16  $name   &f32x);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT16) ? &__HAVE_FLOAT16 : undef)  && (defined(&__HAVE_FLOAT64) ? &__HAVE_FLOAT64 : undef)) {
	    eval 'sub _Mret_ () { &_Float16;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float64;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f16  $name   &f64);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT16) ? &__HAVE_FLOAT16 : undef)  && (defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)) {
	    eval 'sub _Mret_ () { &_Float16;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float64x;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f16  $name   &f64x);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT16) ? &__HAVE_FLOAT16 : undef)  && (defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)) {
	    eval 'sub _Mret_ () { &_Float16;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float128;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f16  $name   &f128);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT16) ? &__HAVE_FLOAT16 : undef)  && (defined(&__HAVE_FLOAT128X) ? &__HAVE_FLOAT128X : undef)) {
	    eval 'sub _Mret_ () { &_Float16;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float128x;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f16  $name   &f128x);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)  && (defined(&__HAVE_FLOAT32X) ? &__HAVE_FLOAT32X : undef)) {
	    eval 'sub _Mret_ () { &_Float32;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float32x;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f32  $name   &f32x);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)  && (defined(&__HAVE_FLOAT64) ? &__HAVE_FLOAT64 : undef)) {
	    eval 'sub _Mret_ () { &_Float32;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float64;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f32  $name   &f64);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)  && (defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)) {
	    eval 'sub _Mret_ () { &_Float32;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float64x;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f32  $name   &f64x);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)  && (defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)) {
	    eval 'sub _Mret_ () { &_Float32;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float128;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f32  $name   &f128);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)  && (defined(&__HAVE_FLOAT128X) ? &__HAVE_FLOAT128X : undef)) {
	    eval 'sub _Mret_ () { &_Float32;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float128x;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f32  $name   &f128x);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT32X) ? &__HAVE_FLOAT32X : undef)  && (defined(&__HAVE_FLOAT64) ? &__HAVE_FLOAT64 : undef)) {
	    eval 'sub _Mret_ () { &_Float32x;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float64;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f32x  $name   &f64);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT32X) ? &__HAVE_FLOAT32X : undef)  && (defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)) {
	    eval 'sub _Mret_ () { &_Float32x;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float64x;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f32x  $name   &f64x);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT32X) ? &__HAVE_FLOAT32X : undef)  && (defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)) {
	    eval 'sub _Mret_ () { &_Float32x;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float128;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f32x  $name   &f128);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT32X) ? &__HAVE_FLOAT32X : undef)  && (defined(&__HAVE_FLOAT128X) ? &__HAVE_FLOAT128X : undef)) {
	    eval 'sub _Mret_ () { &_Float32x;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float128x;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f32x  $name   &f128x);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT64) ? &__HAVE_FLOAT64 : undef)  && (defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)) {
	    eval 'sub _Mret_ () { &_Float64;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float64x;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f64  $name   &f64x);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT64) ? &__HAVE_FLOAT64 : undef)  && (defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)) {
	    eval 'sub _Mret_ () { &_Float64;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float128;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f64  $name   &f128);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT64) ? &__HAVE_FLOAT64 : undef)  && (defined(&__HAVE_FLOAT128X) ? &__HAVE_FLOAT128X : undef)) {
	    eval 'sub _Mret_ () { &_Float64;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float128x;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f64  $name   &f128x);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)  && (defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)) {
	    eval 'sub _Mret_ () { &_Float64x;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float128;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f64x  $name   &f128);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)  && (defined(&__HAVE_FLOAT128X) ? &__HAVE_FLOAT128X : undef)) {
	    eval 'sub _Mret_ () { &_Float64x;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float128x;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f64x  $name   &f128x);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
	if((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  && (defined(&__HAVE_FLOAT128X) ? &__HAVE_FLOAT128X : undef)) {
	    eval 'sub _Mret_ () { &_Float128;}' unless defined(&_Mret_);
	    eval 'sub _Marg_ () { &_Float128x;}' unless defined(&_Marg_);
	    eval 'sub __MATHCALL_NAME {
	        my($name) = @_;
    		eval q( &f128  $name   &f128x);
	    }' unless defined(&__MATHCALL_NAME);
	    require 'bits/mathcalls-narrow.ph';
	    undef(&_Mret_) if defined(&_Mret_);
	    undef(&_Marg_) if defined(&_Marg_);
	    undef(&__MATHCALL_NAME) if defined(&__MATHCALL_NAME);
	}
    }
    undef(&__MATHCALL_NARROW_ARGS_1) if defined(&__MATHCALL_NARROW_ARGS_1);
    undef(&__MATHCALL_NARROW_ARGS_2) if defined(&__MATHCALL_NARROW_ARGS_2);
    undef(&__MATHCALL_NARROW_ARGS_3) if defined(&__MATHCALL_NARROW_ARGS_3);
    undef(&__MATHCALL_NARROW_NORMAL) if defined(&__MATHCALL_NARROW_NORMAL);
    undef(&__MATHCALL_NARROW_REDIR) if defined(&__MATHCALL_NARROW_REDIR);
    undef(&__MATHCALL_NARROW) if defined(&__MATHCALL_NARROW);
    if(defined (&__USE_MISC) || defined (&__USE_XOPEN)) {
    }
    if(((defined(&__HAVE_DISTINCT_FLOAT16) ? &__HAVE_DISTINCT_FLOAT16 : undef) || (defined(&__HAVE_DISTINCT_FLOAT32) ? &__HAVE_DISTINCT_FLOAT32 : undef) || (defined(&__HAVE_DISTINCT_FLOAT64) ? &__HAVE_DISTINCT_FLOAT64 : undef) || (defined(&__HAVE_DISTINCT_FLOAT32X) ? &__HAVE_DISTINCT_FLOAT32X : undef) || (defined(&__HAVE_DISTINCT_FLOAT64X) ? &__HAVE_DISTINCT_FLOAT64X : undef) || (defined(&__HAVE_DISTINCT_FLOAT128X) ? &__HAVE_DISTINCT_FLOAT128X : undef))) {
	die("Unsupported _FloatN or _FloatNx types for <math.h>.");
    }
    if(defined(&__NO_LONG_DOUBLE_MATH)) {
	if((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef)) {
	    die("Distinct _Float128 without distinct long double not supported.");
	}
	eval 'sub __MATH_TG {
	    my($TG_ARG, $FUNC, $ARGS) = @_;
    	    eval q(($sizeof{$TG_ARG} == $sizeof{\'float\'} ? $FUNC   &f $ARGS : $FUNC $ARGS));
	}' unless defined(&__MATH_TG);
    }
 elsif((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef)) {
	if((defined(&__HAVE_GENERIC_SELECTION) ? &__HAVE_GENERIC_SELECTION : undef)) {
	    if((defined(&__HAVE_FLOATN_NOT_TYPEDEF) ? &__HAVE_FLOATN_NOT_TYPEDEF : undef)  && (defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)) {
		eval 'sub __MATH_TG_F32 {
		    my($FUNC, $ARGS) = @_;
    		    eval q( &_Float32: $FUNC   &f $ARGS,);
		}' unless defined(&__MATH_TG_F32);
	    } else {
		eval 'sub __MATH_TG_F32 {
		    my($FUNC, $ARGS) = @_;
    		    eval q();
		}' unless defined(&__MATH_TG_F32);
	    }
	    if((defined(&__HAVE_FLOATN_NOT_TYPEDEF) ? &__HAVE_FLOATN_NOT_TYPEDEF : undef)  && (defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)) {
		if((defined(&__HAVE_FLOAT64X_LONG_DOUBLE) ? &__HAVE_FLOAT64X_LONG_DOUBLE : undef)) {
		    eval 'sub __MATH_TG_F64X {
		        my($FUNC, $ARGS) = @_;
    			eval q( &_Float64x: $FUNC   &l $ARGS,);
		    }' unless defined(&__MATH_TG_F64X);
		} else {
		    eval 'sub __MATH_TG_F64X {
		        my($FUNC, $ARGS) = @_;
    			eval q( &_Float64x: $FUNC   &f128 $ARGS,);
		    }' unless defined(&__MATH_TG_F64X);
		}
	    } else {
		eval 'sub __MATH_TG_F64X {
		    my($FUNC, $ARGS) = @_;
    		    eval q();
		}' unless defined(&__MATH_TG_F64X);
	    }
	    eval 'sub __MATH_TG {
	        my($TG_ARG, $FUNC, $ARGS) = @_;
    		eval q( &_Generic (($TG_ARG), \'float\': $FUNC   &f $ARGS,  &__MATH_TG_F32 ($FUNC, $ARGS)  &default: $FUNC $ARGS, \'long double\': $FUNC   &l $ARGS,  &__MATH_TG_F64X ($FUNC, $ARGS)  &_Float128: $FUNC   &f128 $ARGS));
	    }' unless defined(&__MATH_TG);
	} else {
	    if((defined(&__HAVE_FLOATN_NOT_TYPEDEF) ? &__HAVE_FLOATN_NOT_TYPEDEF : undef)) {
		die("Non-typedef _FloatN but no _Generic.");
	    }
	    eval 'sub __MATH_TG {
	        my($TG_ARG, $FUNC, $ARGS) = @_;
    		eval q( &__builtin_choose_expr ( &__builtin_types_compatible_p ( &__typeof ($TG_ARG), \'float\'), $FUNC   &f $ARGS,  &__builtin_choose_expr ( &__builtin_types_compatible_p ( &__typeof ($TG_ARG), \'double\'), $FUNC $ARGS,  &__builtin_choose_expr ( &__builtin_types_compatible_p ( &__typeof ($TG_ARG), \'long double\'), $FUNC   &l $ARGS, $FUNC   &f128 $ARGS))));
	    }' unless defined(&__MATH_TG);
	}
    } else {
	eval 'sub __MATH_TG {
	    my($TG_ARG, $FUNC, $ARGS) = @_;
    	    eval q(($sizeof{$TG_ARG} == $sizeof{\'float\'} ? $FUNC   &f $ARGS : $sizeof{$TG_ARG} == $sizeof{\'double\'} ? $FUNC $ARGS : $FUNC   &l $ARGS));
	}' unless defined(&__MATH_TG);
    }
    if(defined(&__USE_ISOC99)) {
	eval("sub FP_NAN () { FP_NAN=0; }") unless defined(&FP_NAN);
	eval("sub FP_NAN () { 1; }") unless defined(&FP_NAN);
	eval("sub FP_INFINITE () { FP_INFINITE=1; }") unless defined(&FP_INFINITE);
	eval("sub FP_INFINITE () { 1; }") unless defined(&FP_INFINITE);
	eval("sub FP_ZERO () { FP_ZERO=2; }") unless defined(&FP_ZERO);
	eval("sub FP_ZERO () { 1; }") unless defined(&FP_ZERO);
	eval("sub FP_SUBNORMAL () { FP_SUBNORMAL=3; }") unless defined(&FP_SUBNORMAL);
	eval("sub FP_SUBNORMAL () { 1; }") unless defined(&FP_SUBNORMAL);
	eval("sub FP_NORMAL () { FP_NORMAL=4; }") unless defined(&FP_NORMAL);
	eval("sub FP_NORMAL () { 1; }") unless defined(&FP_NORMAL);
	if((( &__GNUC_PREREQ (4,4)  && !defined (&__SUPPORT_SNAN__)) ||  &__glibc_clang_prereq (2,8))  && (!defined (&__OPTIMIZE_SIZE__) || defined (&__cplusplus))) {
	    eval 'sub fpclassify {
	        my($x) = @_;
    		eval q( &__builtin_fpclassify ( &FP_NAN,  &FP_INFINITE,  &FP_NORMAL,  &FP_SUBNORMAL,  &FP_ZERO, $x));
	    }' unless defined(&fpclassify);
	} else {
	    eval 'sub fpclassify {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__fpclassify, ($x)));
	    }' unless defined(&fpclassify);
	}
	if( &__GNUC_PREREQ (6,0) ||  &__glibc_clang_prereq (3,3)) {
	    eval 'sub signbit {
	        my($x) = @_;
    		eval q( &__builtin_signbit ($x));
	    }' unless defined(&signbit);
	}
 elsif(defined (&__cplusplus)) {
	    eval 'sub signbit {
	        my($x) = @_;
    		eval q( &__builtin_signbitl ($x));
	    }' unless defined(&signbit);
	}
 elsif( &__GNUC_PREREQ (4,0)) {
	    eval 'sub signbit {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__builtin_signbit, ($x)));
	    }' unless defined(&signbit);
	} else {
	    eval 'sub signbit {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__signbit, ($x)));
	    }' unless defined(&signbit);
	}
	if(( &__GNUC_PREREQ (4,4)  && !defined (&__SUPPORT_SNAN__)) ||  &__glibc_clang_prereq (2,8)) {
	    eval 'sub isfinite {
	        my($x) = @_;
    		eval q( &__builtin_isfinite ($x));
	    }' unless defined(&isfinite);
	} else {
	    eval 'sub isfinite {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__finite, ($x)));
	    }' unless defined(&isfinite);
	}
	if(( &__GNUC_PREREQ (4,4)  && !defined (&__SUPPORT_SNAN__)) ||  &__glibc_clang_prereq (2,8)) {
	    eval 'sub isnormal {
	        my($x) = @_;
    		eval q( &__builtin_isnormal ($x));
	    }' unless defined(&isnormal);
	} else {
	    eval 'sub isnormal {
	        my($x) = @_;
    		eval q(( &fpclassify ($x) ==  &FP_NORMAL));
	    }' unless defined(&isnormal);
	}
	if(( &__GNUC_PREREQ (4,4)  && !defined (&__SUPPORT_SNAN__)) ||  &__glibc_clang_prereq (2,8)) {
	    eval 'sub isnan {
	        my($x) = @_;
    		eval q( &__builtin_isnan ($x));
	    }' unless defined(&isnan);
	} else {
	    eval 'sub isnan {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__isnan, ($x)));
	    }' unless defined(&isnan);
	}
	if((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef)  && ! &__GNUC_PREREQ (7,0)  && !defined (&__SUPPORT_SNAN__)  && !defined (&__cplusplus)) {
	    eval 'sub isinf {
	        my($x) = @_;
    		eval q(( &__builtin_types_compatible_p ( &__typeof ($x),  &_Float128) ?  &__isinff128 ($x) :  &__builtin_isinf_sign ($x)));
	    }' unless defined(&isinf);
	}
 elsif(( &__GNUC_PREREQ (4,4)  && !defined (&__SUPPORT_SNAN__)) ||  &__glibc_clang_prereq (3,7)) {
	    eval 'sub isinf {
	        my($x) = @_;
    		eval q( &__builtin_isinf_sign ($x));
	    }' unless defined(&isinf);
	} else {
	    eval 'sub isinf {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__isinf, ($x)));
	    }' unless defined(&isinf);
	}
	eval 'sub MATH_ERRNO () {1;}' unless defined(&MATH_ERRNO);
	eval 'sub MATH_ERREXCEPT () {2;}' unless defined(&MATH_ERREXCEPT);
	if(defined(&__FAST_MATH__)) {
	    eval 'sub math_errhandling () {0;}' unless defined(&math_errhandling);
	}
 elsif(defined (&__NO_MATH_ERRNO__)) {
	    eval 'sub math_errhandling () {( &MATH_ERREXCEPT);}' unless defined(&math_errhandling);
	} else {
	    eval 'sub math_errhandling () {( &MATH_ERRNO |  &MATH_ERREXCEPT);}' unless defined(&math_errhandling);
	}
    }
    if( &__GLIBC_USE ((defined(&IEC_60559_BFP_EXT_C2X) ? &IEC_60559_BFP_EXT_C2X : undef))) {
	require 'bits/iscanonical.ph';
	unless(defined(&__cplusplus)) {
	    eval 'sub issignaling {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__issignaling, ($x)));
	    }' unless defined(&issignaling);
	} else {
	    if(defined(&__NO_LONG_DOUBLE_MATH)) {
	    } else {
	    }
	    if((defined(&__HAVE_FLOAT128_UNLIKE_LDBL) ? &__HAVE_FLOAT128_UNLIKE_LDBL : undef)) {
	    }
	}
	eval 'sub issubnormal {
	    my($x) = @_;
    	    eval q(( &fpclassify ($x) ==  &FP_SUBNORMAL));
	}' unless defined(&issubnormal);
	unless(defined(&__cplusplus)) {
	    if(defined(&__SUPPORT_SNAN__)) {
		eval 'sub iszero {
		    my($x) = @_;
    		    eval q(( &fpclassify ($x) ==  &FP_ZERO));
		}' unless defined(&iszero);
	    } else {
		eval 'sub iszero {
		    my($x) = @_;
    		    eval q(((( &__typeof ($x)) ($x)) == 0));
		}' unless defined(&iszero);
	    }
	} else {
	    if(defined(&__SUPPORT_SNAN__)) {
		if(defined(&__NO_LONG_DOUBLE_MATH)) {
		} else {
		}
		if((defined(&__HAVE_FLOAT128_UNLIKE_LDBL) ? &__HAVE_FLOAT128_UNLIKE_LDBL : undef)) {
		}
	    } else {
	    }
	}
    }
    if(defined(&__USE_XOPEN)) {
	eval 'sub MAXFLOAT () {3.40282347e+38;}' unless defined(&MAXFLOAT);
    }
    if(defined (&__USE_MISC) || defined (&__USE_XOPEN)) {
	eval 'sub M_E () {2.7182818284590452354;}' unless defined(&M_E);
	eval 'sub M_LOG2E () {1.4426950408889634074;}' unless defined(&M_LOG2E);
	eval 'sub M_LOG10E () {0.43429448190325182765;}' unless defined(&M_LOG10E);
	eval 'sub M_LN2 () {0.69314718055994530942;}' unless defined(&M_LN2);
	eval 'sub M_LN10 () {2.30258509299404568402;}' unless defined(&M_LN10);
	eval 'sub M_PI () {3.14159265358979323846;}' unless defined(&M_PI);
	eval 'sub M_PI_2 () {1.57079632679489661923;}' unless defined(&M_PI_2);
	eval 'sub M_PI_4 () {0.78539816339744830962;}' unless defined(&M_PI_4);
	eval 'sub M_1_PI () {0.31830988618379067154;}' unless defined(&M_1_PI);
	eval 'sub M_2_PI () {0.63661977236758134308;}' unless defined(&M_2_PI);
	eval 'sub M_2_SQRTPI () {1.12837916709551257390;}' unless defined(&M_2_SQRTPI);
	eval 'sub M_SQRT2 () {1.41421356237309504880;}' unless defined(&M_SQRT2);
	eval 'sub M_SQRT1_2 () {0.70710678118654752440;}' unless defined(&M_SQRT1_2);
    }
    if(defined(&__USE_GNU)) {
	eval 'sub M_Ef () {2.7182818284590452354 &f;}' unless defined(&M_Ef);
	eval 'sub M_LOG2Ef () {1.4426950408889634074 &f;}' unless defined(&M_LOG2Ef);
	eval 'sub M_LOG10Ef () {0.43429448190325182765 &f;}' unless defined(&M_LOG10Ef);
	eval 'sub M_LN2f () {0.69314718055994530942 &f;}' unless defined(&M_LN2f);
	eval 'sub M_LN10f () {2.30258509299404568402 &f;}' unless defined(&M_LN10f);
	eval 'sub M_PIf () {3.14159265358979323846 &f;}' unless defined(&M_PIf);
	eval 'sub M_PI_2f () {1.57079632679489661923 &f;}' unless defined(&M_PI_2f);
	eval 'sub M_PI_4f () {0.78539816339744830962 &f;}' unless defined(&M_PI_4f);
	eval 'sub M_1_PIf () {0.31830988618379067154 &f;}' unless defined(&M_1_PIf);
	eval 'sub M_2_PIf () {0.63661977236758134308 &f;}' unless defined(&M_2_PIf);
	eval 'sub M_2_SQRTPIf () {1.12837916709551257390 &f;}' unless defined(&M_2_SQRTPIf);
	eval 'sub M_SQRT2f () {1.41421356237309504880 &f;}' unless defined(&M_SQRT2f);
	eval 'sub M_SQRT1_2f () {0.70710678118654752440 &f;}' unless defined(&M_SQRT1_2f);
    }
    if(defined(&__USE_GNU)) {
	eval 'sub M_El () {2.718281828459045235360287471352662498;}' unless defined(&M_El);
	eval 'sub M_LOG2El () {1.442695040888963407359924681001892137;}' unless defined(&M_LOG2El);
	eval 'sub M_LOG10El () {0.434294481903251827651128918916605082;}' unless defined(&M_LOG10El);
	eval 'sub M_LN2l () {0.693147180559945309417232121458176568;}' unless defined(&M_LN2l);
	eval 'sub M_LN10l () {2.302585092994045684017991454684364208;}' unless defined(&M_LN10l);
	eval 'sub M_PIl () {3.141592653589793238462643383279502884;}' unless defined(&M_PIl);
	eval 'sub M_PI_2l () {1.570796326794896619231321691639751442;}' unless defined(&M_PI_2l);
	eval 'sub M_PI_4l () {0.785398163397448309615660845819875721;}' unless defined(&M_PI_4l);
	eval 'sub M_1_PIl () {0.318309886183790671537767526745028724;}' unless defined(&M_1_PIl);
	eval 'sub M_2_PIl () {0.636619772367581343075535053490057448;}' unless defined(&M_2_PIl);
	eval 'sub M_2_SQRTPIl () {1.128379167095512573896158903121545172;}' unless defined(&M_2_SQRTPIl);
	eval 'sub M_SQRT2l () {1.414213562373095048801688724209698079;}' unless defined(&M_SQRT2l);
	eval 'sub M_SQRT1_2l () {0.707106781186547524400844362104849039;}' unless defined(&M_SQRT1_2l);
    }
    if((defined(&__HAVE_FLOAT16) ? &__HAVE_FLOAT16 : undef)  && defined (&__USE_GNU)) {
	eval 'sub M_Ef16 () { &__f16 (2.718281828459045235360287471352662498);}' unless defined(&M_Ef16);
	eval 'sub M_LOG2Ef16 () { &__f16 (1.442695040888963407359924681001892137);}' unless defined(&M_LOG2Ef16);
	eval 'sub M_LOG10Ef16 () { &__f16 (0.434294481903251827651128918916605082);}' unless defined(&M_LOG10Ef16);
	eval 'sub M_LN2f16 () { &__f16 (0.693147180559945309417232121458176568);}' unless defined(&M_LN2f16);
	eval 'sub M_LN10f16 () { &__f16 (2.302585092994045684017991454684364208);}' unless defined(&M_LN10f16);
	eval 'sub M_PIf16 () { &__f16 (3.141592653589793238462643383279502884);}' unless defined(&M_PIf16);
	eval 'sub M_PI_2f16 () { &__f16 (1.570796326794896619231321691639751442);}' unless defined(&M_PI_2f16);
	eval 'sub M_PI_4f16 () { &__f16 (0.785398163397448309615660845819875721);}' unless defined(&M_PI_4f16);
	eval 'sub M_1_PIf16 () { &__f16 (0.318309886183790671537767526745028724);}' unless defined(&M_1_PIf16);
	eval 'sub M_2_PIf16 () { &__f16 (0.636619772367581343075535053490057448);}' unless defined(&M_2_PIf16);
	eval 'sub M_2_SQRTPIf16 () { &__f16 (1.128379167095512573896158903121545172);}' unless defined(&M_2_SQRTPIf16);
	eval 'sub M_SQRT2f16 () { &__f16 (1.414213562373095048801688724209698079);}' unless defined(&M_SQRT2f16);
	eval 'sub M_SQRT1_2f16 () { &__f16 (0.707106781186547524400844362104849039);}' unless defined(&M_SQRT1_2f16);
    }
    if((defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)  && defined (&__USE_GNU)) {
	eval 'sub M_Ef32 () { &__f32 (2.718281828459045235360287471352662498);}' unless defined(&M_Ef32);
	eval 'sub M_LOG2Ef32 () { &__f32 (1.442695040888963407359924681001892137);}' unless defined(&M_LOG2Ef32);
	eval 'sub M_LOG10Ef32 () { &__f32 (0.434294481903251827651128918916605082);}' unless defined(&M_LOG10Ef32);
	eval 'sub M_LN2f32 () { &__f32 (0.693147180559945309417232121458176568);}' unless defined(&M_LN2f32);
	eval 'sub M_LN10f32 () { &__f32 (2.302585092994045684017991454684364208);}' unless defined(&M_LN10f32);
	eval 'sub M_PIf32 () { &__f32 (3.141592653589793238462643383279502884);}' unless defined(&M_PIf32);
	eval 'sub M_PI_2f32 () { &__f32 (1.570796326794896619231321691639751442);}' unless defined(&M_PI_2f32);
	eval 'sub M_PI_4f32 () { &__f32 (0.785398163397448309615660845819875721);}' unless defined(&M_PI_4f32);
	eval 'sub M_1_PIf32 () { &__f32 (0.318309886183790671537767526745028724);}' unless defined(&M_1_PIf32);
	eval 'sub M_2_PIf32 () { &__f32 (0.636619772367581343075535053490057448);}' unless defined(&M_2_PIf32);
	eval 'sub M_2_SQRTPIf32 () { &__f32 (1.128379167095512573896158903121545172);}' unless defined(&M_2_SQRTPIf32);
	eval 'sub M_SQRT2f32 () { &__f32 (1.414213562373095048801688724209698079);}' unless defined(&M_SQRT2f32);
	eval 'sub M_SQRT1_2f32 () { &__f32 (0.707106781186547524400844362104849039);}' unless defined(&M_SQRT1_2f32);
    }
    if((defined(&__HAVE_FLOAT64) ? &__HAVE_FLOAT64 : undef)  && defined (&__USE_GNU)) {
	eval 'sub M_Ef64 () { &__f64 (2.718281828459045235360287471352662498);}' unless defined(&M_Ef64);
	eval 'sub M_LOG2Ef64 () { &__f64 (1.442695040888963407359924681001892137);}' unless defined(&M_LOG2Ef64);
	eval 'sub M_LOG10Ef64 () { &__f64 (0.434294481903251827651128918916605082);}' unless defined(&M_LOG10Ef64);
	eval 'sub M_LN2f64 () { &__f64 (0.693147180559945309417232121458176568);}' unless defined(&M_LN2f64);
	eval 'sub M_LN10f64 () { &__f64 (2.302585092994045684017991454684364208);}' unless defined(&M_LN10f64);
	eval 'sub M_PIf64 () { &__f64 (3.141592653589793238462643383279502884);}' unless defined(&M_PIf64);
	eval 'sub M_PI_2f64 () { &__f64 (1.570796326794896619231321691639751442);}' unless defined(&M_PI_2f64);
	eval 'sub M_PI_4f64 () { &__f64 (0.785398163397448309615660845819875721);}' unless defined(&M_PI_4f64);
	eval 'sub M_1_PIf64 () { &__f64 (0.318309886183790671537767526745028724);}' unless defined(&M_1_PIf64);
	eval 'sub M_2_PIf64 () { &__f64 (0.636619772367581343075535053490057448);}' unless defined(&M_2_PIf64);
	eval 'sub M_2_SQRTPIf64 () { &__f64 (1.128379167095512573896158903121545172);}' unless defined(&M_2_SQRTPIf64);
	eval 'sub M_SQRT2f64 () { &__f64 (1.414213562373095048801688724209698079);}' unless defined(&M_SQRT2f64);
	eval 'sub M_SQRT1_2f64 () { &__f64 (0.707106781186547524400844362104849039);}' unless defined(&M_SQRT1_2f64);
    }
    if((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  && defined (&__USE_GNU)) {
	eval 'sub M_Ef128 () { &__f128 (2.718281828459045235360287471352662498);}' unless defined(&M_Ef128);
	eval 'sub M_LOG2Ef128 () { &__f128 (1.442695040888963407359924681001892137);}' unless defined(&M_LOG2Ef128);
	eval 'sub M_LOG10Ef128 () { &__f128 (0.434294481903251827651128918916605082);}' unless defined(&M_LOG10Ef128);
	eval 'sub M_LN2f128 () { &__f128 (0.693147180559945309417232121458176568);}' unless defined(&M_LN2f128);
	eval 'sub M_LN10f128 () { &__f128 (2.302585092994045684017991454684364208);}' unless defined(&M_LN10f128);
	eval 'sub M_PIf128 () { &__f128 (3.141592653589793238462643383279502884);}' unless defined(&M_PIf128);
	eval 'sub M_PI_2f128 () { &__f128 (1.570796326794896619231321691639751442);}' unless defined(&M_PI_2f128);
	eval 'sub M_PI_4f128 () { &__f128 (0.785398163397448309615660845819875721);}' unless defined(&M_PI_4f128);
	eval 'sub M_1_PIf128 () { &__f128 (0.318309886183790671537767526745028724);}' unless defined(&M_1_PIf128);
	eval 'sub M_2_PIf128 () { &__f128 (0.636619772367581343075535053490057448);}' unless defined(&M_2_PIf128);
	eval 'sub M_2_SQRTPIf128 () { &__f128 (1.128379167095512573896158903121545172);}' unless defined(&M_2_SQRTPIf128);
	eval 'sub M_SQRT2f128 () { &__f128 (1.414213562373095048801688724209698079);}' unless defined(&M_SQRT2f128);
	eval 'sub M_SQRT1_2f128 () { &__f128 (0.707106781186547524400844362104849039);}' unless defined(&M_SQRT1_2f128);
    }
    if((defined(&__HAVE_FLOAT32X) ? &__HAVE_FLOAT32X : undef)  && defined (&__USE_GNU)) {
	eval 'sub M_Ef32x () { &__f32x (2.718281828459045235360287471352662498);}' unless defined(&M_Ef32x);
	eval 'sub M_LOG2Ef32x () { &__f32x (1.442695040888963407359924681001892137);}' unless defined(&M_LOG2Ef32x);
	eval 'sub M_LOG10Ef32x () { &__f32x (0.434294481903251827651128918916605082);}' unless defined(&M_LOG10Ef32x);
	eval 'sub M_LN2f32x () { &__f32x (0.693147180559945309417232121458176568);}' unless defined(&M_LN2f32x);
	eval 'sub M_LN10f32x () { &__f32x (2.302585092994045684017991454684364208);}' unless defined(&M_LN10f32x);
	eval 'sub M_PIf32x () { &__f32x (3.141592653589793238462643383279502884);}' unless defined(&M_PIf32x);
	eval 'sub M_PI_2f32x () { &__f32x (1.570796326794896619231321691639751442);}' unless defined(&M_PI_2f32x);
	eval 'sub M_PI_4f32x () { &__f32x (0.785398163397448309615660845819875721);}' unless defined(&M_PI_4f32x);
	eval 'sub M_1_PIf32x () { &__f32x (0.318309886183790671537767526745028724);}' unless defined(&M_1_PIf32x);
	eval 'sub M_2_PIf32x () { &__f32x (0.636619772367581343075535053490057448);}' unless defined(&M_2_PIf32x);
	eval 'sub M_2_SQRTPIf32x () { &__f32x (1.128379167095512573896158903121545172);}' unless defined(&M_2_SQRTPIf32x);
	eval 'sub M_SQRT2f32x () { &__f32x (1.414213562373095048801688724209698079);}' unless defined(&M_SQRT2f32x);
	eval 'sub M_SQRT1_2f32x () { &__f32x (0.707106781186547524400844362104849039);}' unless defined(&M_SQRT1_2f32x);
    }
    if((defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)  && defined (&__USE_GNU)) {
	eval 'sub M_Ef64x () { &__f64x (2.718281828459045235360287471352662498);}' unless defined(&M_Ef64x);
	eval 'sub M_LOG2Ef64x () { &__f64x (1.442695040888963407359924681001892137);}' unless defined(&M_LOG2Ef64x);
	eval 'sub M_LOG10Ef64x () { &__f64x (0.434294481903251827651128918916605082);}' unless defined(&M_LOG10Ef64x);
	eval 'sub M_LN2f64x () { &__f64x (0.693147180559945309417232121458176568);}' unless defined(&M_LN2f64x);
	eval 'sub M_LN10f64x () { &__f64x (2.302585092994045684017991454684364208);}' unless defined(&M_LN10f64x);
	eval 'sub M_PIf64x () { &__f64x (3.141592653589793238462643383279502884);}' unless defined(&M_PIf64x);
	eval 'sub M_PI_2f64x () { &__f64x (1.570796326794896619231321691639751442);}' unless defined(&M_PI_2f64x);
	eval 'sub M_PI_4f64x () { &__f64x (0.785398163397448309615660845819875721);}' unless defined(&M_PI_4f64x);
	eval 'sub M_1_PIf64x () { &__f64x (0.318309886183790671537767526745028724);}' unless defined(&M_1_PIf64x);
	eval 'sub M_2_PIf64x () { &__f64x (0.636619772367581343075535053490057448);}' unless defined(&M_2_PIf64x);
	eval 'sub M_2_SQRTPIf64x () { &__f64x (1.128379167095512573896158903121545172);}' unless defined(&M_2_SQRTPIf64x);
	eval 'sub M_SQRT2f64x () { &__f64x (1.414213562373095048801688724209698079);}' unless defined(&M_SQRT2f64x);
	eval 'sub M_SQRT1_2f64x () { &__f64x (0.707106781186547524400844362104849039);}' unless defined(&M_SQRT1_2f64x);
    }
    if((defined(&__HAVE_FLOAT128X) ? &__HAVE_FLOAT128X : undef)  && defined (&__USE_GNU)) {
	die("M_* values needed for _Float128x");
    }
    if(defined(&__USE_ISOC99)) {
	if( &__GNUC_PREREQ (3, 1)) {
	    eval 'sub isgreater {
	        my($x, $y) = @_;
    		eval q( &__builtin_isgreater($x, $y));
	    }' unless defined(&isgreater);
	    eval 'sub isgreaterequal {
	        my($x, $y) = @_;
    		eval q( &__builtin_isgreaterequal($x, $y));
	    }' unless defined(&isgreaterequal);
	    eval 'sub isless {
	        my($x, $y) = @_;
    		eval q( &__builtin_isless($x, $y));
	    }' unless defined(&isless);
	    eval 'sub islessequal {
	        my($x, $y) = @_;
    		eval q( &__builtin_islessequal($x, $y));
	    }' unless defined(&islessequal);
	    eval 'sub islessgreater {
	        my($x, $y) = @_;
    		eval q( &__builtin_islessgreater($x, $y));
	    }' unless defined(&islessgreater);
	    eval 'sub isunordered {
	        my($x, $y) = @_;
    		eval q( &__builtin_isunordered($x, $y));
	    }' unless defined(&isunordered);
	} else {
	    eval 'sub isgreater {
	        my($x, $y) = @_;
    		eval q(( &__extension__ ({  &__typeof__ ($x)  &__x = ($x);  &__typeof__ ($y)  &__y = ($y); ! &isunordered ( &__x,  &__y)  &&  &__x >  &__y; })));
	    }' unless defined(&isgreater);
	    eval 'sub isgreaterequal {
	        my($x, $y) = @_;
    		eval q(( &__extension__ ({  &__typeof__ ($x)  &__x = ($x);  &__typeof__ ($y)  &__y = ($y); ! &isunordered ( &__x,  &__y)  &&  &__x >=  &__y; })));
	    }' unless defined(&isgreaterequal);
	    eval 'sub isless {
	        my($x, $y) = @_;
    		eval q(( &__extension__ ({  &__typeof__ ($x)  &__x = ($x);  &__typeof__ ($y)  &__y = ($y); ! &isunordered ( &__x,  &__y)  &&  &__x <  &__y; })));
	    }' unless defined(&isless);
	    eval 'sub islessequal {
	        my($x, $y) = @_;
    		eval q(( &__extension__ ({  &__typeof__ ($x)  &__x = ($x);  &__typeof__ ($y)  &__y = ($y); ! &isunordered ( &__x,  &__y)  &&  &__x <=  &__y; })));
	    }' unless defined(&islessequal);
	    eval 'sub islessgreater {
	        my($x, $y) = @_;
    		eval q(( &__extension__ ({  &__typeof__ ($x)  &__x = ($x);  &__typeof__ ($y)  &__y = ($y); ! &isunordered ( &__x,  &__y)  &&  &__x !=  &__y; })));
	    }' unless defined(&islessgreater);
	    eval 'sub isunordered {
	        my($x, $y) = @_;
    		eval q(( &__extension__ ({  &__typeof__ ($x)  &__u = ($x);  &__typeof__ ($y)  &__v = ($y);  &__u !=  &__v  && ( &__u !=  &__u ||  &__v !=  &__v); })));
	    }' unless defined(&isunordered);
	}
    }
    if( &__GLIBC_USE ((defined(&IEC_60559_BFP_EXT_C2X) ? &IEC_60559_BFP_EXT_C2X : undef))) {
	if((defined(&__FLT_EVAL_METHOD__) ? &__FLT_EVAL_METHOD__ : undef) == 2|| (defined(&__FLT_EVAL_METHOD__) ? &__FLT_EVAL_METHOD__ : undef) > 64) {
	    eval 'sub __MATH_EVAL_FMT2 {
	        my($x, $y) = @_;
    		eval q((($x) + ($y) + 0.0));
	    }' unless defined(&__MATH_EVAL_FMT2);
	}
 elsif((defined(&__FLT_EVAL_METHOD__) ? &__FLT_EVAL_METHOD__ : undef) == 1|| (defined(&__FLT_EVAL_METHOD__) ? &__FLT_EVAL_METHOD__ : undef) > 32) {
	    eval 'sub __MATH_EVAL_FMT2 {
	        my($x, $y) = @_;
    		eval q((($x) + ($y) + 0.0));
	    }' unless defined(&__MATH_EVAL_FMT2);
	}
 elsif((defined(&__FLT_EVAL_METHOD__) ? &__FLT_EVAL_METHOD__ : undef) == 0|| (defined(&__FLT_EVAL_METHOD__) ? &__FLT_EVAL_METHOD__ : undef) == 32) {
	    eval 'sub __MATH_EVAL_FMT2 {
	        my($x, $y) = @_;
    		eval q((($x) + ($y) + 0.0 &f));
	    }' unless defined(&__MATH_EVAL_FMT2);
	} else {
	    eval 'sub __MATH_EVAL_FMT2 {
	        my($x, $y) = @_;
    		eval q((($x) + ($y)));
	    }' unless defined(&__MATH_EVAL_FMT2);
	}
	if(!defined (&__cplusplus) || ((defined(&__cplusplus) ? &__cplusplus : undef) < 201103  && !defined (&__GNUC__))) {
	    eval 'sub iseqsig {
	        my($x, $y) = @_;
    		eval q( &__MATH_TG ( &__MATH_EVAL_FMT2 ($x, $y),  &__iseqsig, (($x), ($y))));
	    }' unless defined(&iseqsig);
	} else {
	    unless(defined(&__NO_LONG_DOUBLE_MATH)) {
	    } else {
	    }
	    if((defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)  &&  &__GNUC_PREREQ (13, 0)) {
	    }
	    if((defined(&__HAVE_FLOAT64) ? &__HAVE_FLOAT64 : undef)  &&  &__GNUC_PREREQ (13, 0)) {
	    }
	    if((defined(&__HAVE_FLOAT128_UNLIKE_LDBL) ? &__HAVE_FLOAT128_UNLIKE_LDBL : undef) || ((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  &&  &__GNUC_PREREQ (13, 0))) {
		if((defined(&__HAVE_FLOAT128_UNLIKE_LDBL) ? &__HAVE_FLOAT128_UNLIKE_LDBL : undef)) {
		} else {
		}
	    }
	    if((defined(&__HAVE_FLOAT32X) ? &__HAVE_FLOAT32X : undef)  &&  &__GNUC_PREREQ (13, 0)) {
	    }
	    if((defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)  &&  &__GNUC_PREREQ (13, 0)) {
		if((defined(&__HAVE_FLOAT64X_LONG_DOUBLE) ? &__HAVE_FLOAT64X_LONG_DOUBLE : undef)) {
		} else {
		}
	    }
	    if((defined(&__cplusplus) ? &__cplusplus : undef) >= 201103) {
	    } else {
	    }
	}
    }
}
1;
